## editorconfig-core 0.11.5

=== CMakeLists.txt ===
#
# Copyright (c) 2011-2013 EditorConfig Team
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

cmake_minimum_required(VERSION 2.6)

set (editorconfig_VERSION_MAJOR 0)
set (editorconfig_VERSION_MINOR 11)
set (editorconfig_VERSION_SUBMINOR 5)

set (editorconfig_VERSION_SUFFIX "")

project(editorconfig C)

# set default compilation directory
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P
    ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# package target
set(HOME_URL "http://editorconfig.org")
set(MAILING_LIST "editorconfig@googlegroups.com")

set(CPACK_PACKAGE_VENDOR "EditorConfig Team")
set(CPACK_PACKAGE_VERSION_MAJOR ${editorconfig_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${editorconfig_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${editorconfig_VERSION_SUBMINOR})
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "editorconfig")

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin") # Mac OS X
    set(CPACK_GENERATOR "STGZ;TGZ;TZ")
elseif(UNIX)
    # UNIX should be checked before WIN32 since cygwin makes UNIX and WIN32
    # both true
    set(CPACK_GENERATOR "STGZ;TGZ;TZ;DEB;RPM")
elseif(WIN32)
    set(CPACK_GENERATOR "ZIP;NSIS")
endif()

set(CPACK_MONOLITHIC_INSTALL 1)
set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
set(CPACK_PACKAGE_CONTACT "EditorConfig <${MAILING_LIST}>")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/README.md)
set(CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
# get the architecture of Deb package. The name of the architecture is not
# always the same with ${CMAKE_SYSTEM_PROCESSOR}
if(NOT CPACK_DEBIAN_PACKAGE_ARCHITECTURE)
    execute_process(COMMAND dpkg --print-architecture
        OUTPUT_VARIABLE arch OUTPUT_STRIP_TRAILING_WHITESPACE)
    set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "${arch}")
endif()
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE ${HOME_URL})
set(CPACK_NSIS_CONTACT ${CPACK_PACKAGE_CONTACT})
set(CPACK_NSIS_DISPLAY_NAME "EditorConfig Core")
set(CPACK_NSIS_PACKAGE_HOMEPAGE ${HOME_URL})
set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "editorconfig")
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
set(CPACK_RPM_PACKAGE_LICENSE "Simplified BSD license")
set(CPACK_RPM_PACKAGE_URL ${HOME_URL})
include(CPack)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(include)

# Testing. Type "make test" to run tests. Only if the test submodule is
# checkouted should we do this
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/tests/CMakeLists.txt)
    enable_testing()
    set(EDITORCONFIG_CMD "${PROJECT_BINARY_DIR}/bin/editorconfig")
    add_subdirectory(tests)
else()
    message(WARNING
        " Testing files are not found. Testing will not be available. If you obtained the source tree through git, please run `git submodule update --init` to update the tests submodule.")
endif()

=== doc/CMakeLists.txt ===
#
# Copyright (c) 2011-2012 EditorConfig Team
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

option(BUILD_DOCUMENTATION
    "Use Doxygen to create the HTML and man page documentation" ON)

# Whether to install the html documentation. Only valid when
# BUILD_DOCUMENTATION is set to ON
option(INSTALL_HTML_DOC
    "Install the generated html documentation" OFF)

if(BUILD_DOCUMENTATION)

    find_package(Doxygen)

    if(DOXYGEN_FOUND)

        # Generating the major part of the doc. Although it generates
        # editorconfig.3, we discard that file
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
            ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
            COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
            MAIN_DEPENDENCY
            ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
            DEPENDS
            ${PROJECT_SOURCE_DIR}/include/editorconfig/editorconfig.h
            ${PROJECT_SOURCE_DIR}/include/editorconfig/editorconfig_handle.h
            ${PROJECT_SOURCE_DIR}/logo/logo.png
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

        # Generating man page of editorconfig command. Although we have other
        # .1s other than editorconfig.1, we ignore them
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_cmd.in
            ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_cmd)

        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/man/man1/editorconfig.1
            COMMAND
            ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_cmd"
            MAIN_DEPENDENCY
            ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_cmd.in
            DEPENDS
            ${PROJECT_SOURCE_DIR}/include/editorconfig/editorconfig.h
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

        add_custom_target(doc ALL DEPENDS
            ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
            ${CMAKE_CURRENT_BINARY_DIR}/man/man1/editorconfig.1)

        # install man pages
        set(EC_MANPAGE_DIR ${CMAKE_CURRENT_BINARY_DIR}/man)
        set(EC_MANPAGE3_DIR ${EC_MANPAGE_DIR}/man3)

        # Since we cannot avoid generating editorconfig.3 with doxygen, which
        # is the manpage of the command line interface with a manpage number 3,
        # we need to exclude it when installing man3.
        install(DIRECTORY ${EC_MANPAGE3_DIR}
            DESTINATION share/man
            PATTERN editorconfig.3 EXCLUDE)

        set(EC_MANPAGE1_DIR ${EC_MANPAGE_DIR}/man1)

        install(FILES
            ${EC_MANPAGE1_DIR}/editorconfig.1
            DESTINATION share/man/man1)

        # "make clean" should also clean generated docs
        set_directory_properties(PROPERTIES
            ADDITIONAL_MAKE_CLEAN_FILES "html;man")

        if(INSTALL_HTML_DOC)
            install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html"
                DESTINATION share/doc/editorconfig)
        endif(INSTALL_HTML_DOC)

    else(DOXYGEN_FOUND)
        message(WARNING
            " Doxygen is not found. Documentation will not be generated.")
    endif(DOXYGEN_FOUND)
endif(BUILD_DOCUMENTATION)

=== src/CMakeLists.txt ===
#
# Copyright (c) 2011-2012 EditorConfig Team
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

include(CheckFunctionExists)
include(CheckTypeSize)

# config.h will be generated in src/auto, we should include it.
include_directories(BEFORE
    ${CMAKE_CURRENT_BINARY_DIR}/auto)

check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(strdup HAVE_STRDUP)
check_function_exists(stricmp HAVE_STRICMP)
check_function_exists(strndup HAVE_STRNDUP)
check_function_exists(strlwr HAVE_STRLWR)

check_type_size(_Bool HAVE__BOOL)
check_type_size("const char*" HAVE_CONST)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/auto/config.h)

include_directories(BEFORE
    "${PROJECT_SOURCE_DIR}/include")

# MSVC_MD option
option(MSVC_MD
    "Use /MD instead of /MT flag when compiling with Microsoft Visual C++. This option takes no effect when using compilers other than Microsoft Visual C++."
    OFF)

# replace all /MD with /MT for msvc if MSVC_MD is off
if(MSVC AND NOT MSVC_MD)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
        if(${flag_var} MATCHES "/MD")
            string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endif(${flag_var} MATCHES "/MD")
    endforeach(flag_var)
endif()

add_subdirectory(lib)
add_subdirectory(bin)

=== src/lib/CMakeLists.txt ===
#
# Copyright (c) 2011-2012 EditorConfig Team
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

set(editorconfig_LIBSRCS
    ec_fnmatch.c
    editorconfig.c
    editorconfig_handle.c
    ini.c
    misc.c
    )

add_library(editorconfig_shared SHARED ${editorconfig_LIBSRCS})
set_target_properties(editorconfig_shared PROPERTIES
    OUTPUT_NAME editorconfig
    SOVERSION 0
    VERSION
    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_SUBMINOR})

# We need to link Shwapi since we use PathIsRelative
if(WIN32)
    target_link_libraries(editorconfig_shared Shlwapi)
endif()

add_library(editorconfig_static STATIC ${editorconfig_LIBSRCS})
set_target_properties(editorconfig_static PROPERTIES
    OUTPUT_NAME editorconfig_static
    VERSION
    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_SUBMINOR})

# We need to link Shwapi since we use PathIsRelative
if(WIN32)
    target_link_libraries(editorconfig_static Shlwapi)
endif()

install(TARGETS editorconfig_shared editorconfig_static
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)

=== debian/changelog ===
editorconfig-core (0.11.5-1) unstable; urgency=low

  [ Jonas Smedegaard ]
  * Fix a typo in short description.
  * Add README.source emphasizing control.in file as *not* a
    show-stopper for contributions, referring to
    CDBS+git-buildpackage wiki page for details.

  [ Vasudev Kamath ]
  * Imported Upstream version 0.11.5
  * Moved doxygen into build-depends from build-depends-indep as it is
    generating man pages needed by the package.
    Closes: bug#705682
  * Use DEB_UPSTREAM_VERSION instead of hard coding upstream version in
    arguments to dh_link for editorconfig package.
  * Add multi-arch related quirks, including missing ${cdbs:Pre-Depends}
    substitution value.

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Mon, 10 Jun 2013 19:52:34 +0530

editorconfig-core (0.11.0-1) unstable; urgency=low

  [ Vasudev Kamath ]
  * Initial release.
    Closes: bug#679663.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 29 Mar 2013 16:41:00 +0100

=== debian/control ===
Source: editorconfig-core
Section: libs
Priority: optional
Build-Depends: cdbs,
 debhelper,
 dh-buildinfo,
 devscripts,
 cmake,
 d-shlibs,
 doxygen
Maintainer: Jonas Smedegaard <dr@jones.dk>
Uploaders: Vasudev Kamath <kamathvasudev@gmail.com>
Standards-Version: 3.9.4
Homepage: http://editorconfig.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/editorconfig-core.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/editorconfig-core.git

Package: libeditorconfig0
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends},
 ${cdbs:Pre-Depends}
Multi-Arch: same
Description: coding style indenter across editors - library
 EditorConfig helps developers define and maintain consistent coding
 styles between different editors and IDEs. The EditorConfig project
 consists of a file format for defining coding styles and a collection
 of text editor plugins that enable editors to read the file format
 and adhere to defined styles.
 .
 EditorConfig files are easily readable and they work nicely
 with version control systems.
 .
 This package provides the core library of editorconfig.

Package: libeditorconfig-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeditorconfig0 (= ${binary:Version}),
 ${devlibs:Depends},
 ${misc:Depends}
Suggests: editorconfig-doc
Description: coding style indenter across editors - development files
 EditorConfig helps developers define and maintain consistent coding
 styles between different editors and IDEs. The EditorConfig project
 consists of a file format for defining coding styles and a collection
 of text editor plugins that enable editors to read the file format
 and adhere to defined styles.
 .
 EditorConfig files are easily readable and they work nicely
 with version control systems.
 .
 This package provides development headers for editorconfig-core library.

Package: libeditorconfig0-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libeditorconfig0 (= ${binary:Version}),
 ${misc:Depends}
Description: coding style indenter across editors - debugging symbols
 EditorConfig helps developers define and maintain consistent coding
 styles between different editors and IDEs. The EditorConfig project
 consists of a file format for defining coding styles and a collection
 of text editor plugins that enable editors to read the file format
 and adhere to defined styles.
 .
 EditorConfig files are easily readable and they work nicely
 with version control systems.
 .
 This package provides debugging symbols for editorconfig-core
 library.

Package: editorconfig
Section: utils
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: coding style indenter for all editors - commandline tools
 This package helps developers define and maintain consistent coding
 styles between different editors and IDEs. The EditorConfig project
 consists of a file format for defining coding styles and a collection
 of text editor plugins that enable editors to read the file format
 and adhere to defined styles.
 .
 EditorConfig files are easily readable and they work nicely
 with version control systems.
 .
 This package provides editorconfig command which can be used to
 reformat and indent code files using editorconfig configuration file.

Package: editorconfig-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
 ${cdbs:Depends}
Description: coding style indenter across editors - documentation
 EditorConfig helps developers define and maintain consistent coding
 styles between different editors and IDEs. The EditorConfig project
 consists of a file format for defining coding styles and a collection
 of text editor plugins that enable editors to read the file format
 and adhere to defined styles.
 .
 EditorConfig files are easily readable and they work nicely
 with version control systems.
 .
 This package provides API documentation for editorconfig-core library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2013 Vasudev Kamath <kamathvasudev@gmail.com>
# Copyright © 2013 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for EditorConfig core
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed -e 's/__LIBPKGNAME__/$(libpkg)/g' <debian/control.in.in >debian/control.in

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/cmake.mk

stem = editorconfig
major = $(firstword $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))
lib = lib$(stem)
libpkg = $(lib)$(major)
devpkg = $(lib)-dev
utilspkg = $(stem)
docpkg = $(stem)-doc

# Upstream tarball handling
DEB_UPSTREAM_URL = https://github.com/editorconfig/editorconfig-core/archive
DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)
DEB_UPSTREAM_TARBALL_MD5 = 70107f17246188953c65766217e5261a

# Build Depends
CDBS_BUILD_DEPENDS += , cmake, d-shlibs, doxygen

# Depends
CDBS_DEPENDS_$(docpkg) += , libjs-jquery

# enable installation of HTML docs
DEB_CMAKE_NORMAL_ARGS += -DINSTALL_HTML_DOC=ON

# use standard LDFLAGS
DEB_CMAKE_NORMAL_ARGS += -DCMAKE_EXE_LINKER_FLAGS="${LDFLAGS}" -DCMAKE_SHARED_LINKER_FLAGS="${LDFLAGS}"

# Supress optional build dependencies
CDBS_BUILD_DEPENDS_rules_upstream_tarball =
CDBS_BUILD_DEPENDS_rules_utils_copyright_check =

# Multiarch quirks (should ideally be resolved automagically)
CDBS_BUILD_DEPENDS_rules_debhelper_buildinfo =
CDBS_BUILD_DEPENDS_rules_buildcore_pkgrel =
CDBS_PREDEPENDS = $(if $(DEB_HOST_MULTIARCH),multiarch-support)


# install editorconfig binaries, man pages and docs
DEB_DH_INSTALL_ARGS_$(utilspkg) = usr/bin
DEB_INSTALL_MANPAGES_$(utilspkg) = debian/tmp/usr/share/man/man1/editorconfig.1 debian/tmp/usr/share/man/man3/editorconfig-format.3
DEB_DH_LINK_$(utilspkg) = /usr/share/man/man1/editorconfig.1.gz /usr/share/man/man1/editorconfig-$(DEB_UPSTREAM_VERSION).1.gz
DEB_DH_INSTALL_ARGS_$(docpkg) = usr/share/doc/editorconfig-doc/html/
DEB_DH_LINK_$(docpkg) = /usr/share/javascript/jquery/jquery.js /usr/share/doc/$(docpkg)/html/jquery.js

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
binary-post-install/$(libpkg) binary-post-install/$(devpkg):: debian/stamp-local-shlibs-$(lib)
debian/stamp-local-shlibs-$(lib): binary-install/$(libpkg) binary-install/$(devpkg)
	d-shlibmove --commit \
		--devunversioned \
		--multiarch \
		--exclude-la \
		--override s/$(lib)$(major)-dev/$(lib)-dev/ \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(lib).so
	touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(lib)

binary-post-install/$(docpkg)::
	rm -f debian/$(docpkg)/usr/share/doc/$(docpkg)/html/jquery.js

=== debian/watch ===
version = 3
https://github.com/editorconfig/editorconfig-core/tags .*/v(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## editorconfig-core 0.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,12 +27,14 @@
 cmake_minimum_required(VERSION 2.6)
 
 set (editorconfig_VERSION_MAJOR 0)
-set (editorconfig_VERSION_MINOR 11)
-set (editorconfig_VERSION_SUBMINOR 5)
+set (editorconfig_VERSION_MINOR 12)
+set (editorconfig_VERSION_SUBMINOR 0)
 
 set (editorconfig_VERSION_SUFFIX "")
 
 project(editorconfig C)
+
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake_Modules")
 
 # set default compilation directory
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2011-2012 EditorConfig Team
+# Copyright (c) 2011-2013 EditorConfig Team
 # All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
@@ -82,7 +82,8 @@
         # we need to exclude it when installing man3.
         install(DIRECTORY ${EC_MANPAGE3_DIR}
             DESTINATION share/man
-            PATTERN editorconfig.3 EXCLUDE)
+            PATTERN editorconfig.3 EXCLUDE
+            REGEX ._include_. EXCLUDE)
 
         set(EC_MANPAGE1_DIR ${EC_MANPAGE_DIR}/man1)

=== include/CMakeLists.txt ===
#
# Copyright (c) 2011-2012 EditorConfig Team
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

install(FILES
    editorconfig/editorconfig.h
    editorconfig/editorconfig_handle.h
    DESTINATION include/editorconfig)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,13 @@
 
 include(CheckFunctionExists)
 include(CheckTypeSize)
+
+find_package(PCRE REQUIRED)
+
+if(PCRE_FOUND)
+    include_directories(BEFORE ${PCRE_INCLUDE_DIRS})
+    option(PCRE_STATIC "Turn this option ON when linking to PCRE static library" OFF)
+endif()
 
 # config.h will be generated in src/auto, we should include it.
 include_directories(BEFORE

=== debian/changelog ===
editorconfig-core (0.12.0-2) unstable; urgency=medium

  * Fix have -doc package symlink externally packaged jquery.
    Build-depend (not only depend) on libjs-jquery.
  * Update copyright info: Extend coverage for myself.
  * Resolve major version from upstream code (not changelog version.
  * Modernize git-buildpackage config: Drop "git-" prefix.
  * Avoid compressing documentation.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 02 May 2015 14:28:45 +0200

editorconfig-core (0.12.0-1) experimental; urgency=medium

  [ upstream ]
  * New release.
    Closes: bug#767189, Thanks to Hong Xu.

  [ Vasudev Kamath ]
  * Update source URL in copyright and watch file to reflect upstream
    renaming of project to editorconfig-core-c.
  * Update copyright file:
    + Add Files sections for newly added files.
    + Drop Files section for no longer shipped ec_fnmatch.* files, and
      drop now unused BSD-3-clause License section.
  * Build-depend on libpcre3-dev.
  * Declare compliance with Standards-Version 3.9.6.
  * Add patch 1002 to make package build reproducible.

  [ Jonas Smedegaard ]
  * Modernize CDBS use:
    + Stop explicitly pass LDFLAGS: Done implicitly since cdbs 0.4.122.
    + Stop suppress optional build dependencies: available even in
      oldstable.
  * Update Vcs-Browser field to use canonical https protocol.
  * Stop track upstream tarball checksum.
  * Simplify watch file.
  * Fix tighten build-dependency on d-shlibs: Needed for --multiarch and
    --exclude-la options.
  * Unfuzz and reorder patches.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 12 Mar 2015 22:00:51 +0100

editorconfig-core (0.11.5-2) unstable; urgency=medium

  * Bump Standards-Version to 3.9.5, no change to package source.
  * Replace gitweb url with cgit URL in Vcs-Browser field.
  * Mark -dbg package as Multi-Arch same
  * Bump compat to 9 to fix Multi-Arch -dbg package generation

 -- Vasudev Kamath <kamathvasudev@gmail.com>  Thu, 14 Aug 2014 22:18:07 +0530

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,19 @@
 Section: libs
 Priority: optional
 Build-Depends: cdbs,
- debhelper,
- dh-buildinfo,
+ debhelper (>= 9~),
  devscripts,
  cmake,
- d-shlibs,
- doxygen
+ doxygen,
+ libpcre3-dev,
+ d-shlibs (>= 0.48),
+ libjs-jquery
 Maintainer: Jonas Smedegaard <dr@jones.dk>
 Uploaders: Vasudev Kamath <kamathvasudev@gmail.com>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://editorconfig.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/editorconfig-core.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/editorconfig-core.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/editorconfig-core.git
 
 Package: libeditorconfig0
 Section: libs
@@ -59,6 +60,7 @@
 Section: debug
 Priority: extra
 Architecture: any
+Multi-Arch: same
 Depends: libeditorconfig0 (= ${binary:Version}),
  ${misc:Depends}
 Description: coding style indenter across editors - debugging symbols

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2013 Vasudev Kamath <kamathvasudev@gmail.com>
# Copyright © 2013, 2015 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for EditorConfig core
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This needs to declared/run before including CDBS snippets
stem = editorconfig
major := $(shell perl -ne '/^set .editorconfig_VERSION_MAJOR +(\d+)/ and print $$1' CMakeLists.txt)
pkg-lib = $(lib)$(major)
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed -e 's/__LIBPKGNAME__/$(pkg-lib)/g' \
		< debian/control.in.in \
		> debian/control.in

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/class/cmake.mk

lib = lib$(stem)
pkg-dev = $(lib)-dev
pkg-bin = $(stem)
pkg-doc = $(stem)-doc

# Upstream tarball handling
DEB_UPSTREAM_URL = https://github.com/editorconfig/editorconfig-core/archive
DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)

# Build Depends
CDBS_BUILD_DEPENDS += , cmake, doxygen, libpcre3-dev

# enable installation of HTML docs
DEB_CMAKE_NORMAL_ARGS += -DINSTALL_HTML_DOC=ON

# Multiarch quirks (should ideally be resolved automagically)
CDBS_BUILD_DEPENDS_rules_debhelper_buildinfo =
CDBS_BUILD_DEPENDS_rules_buildcore_pkgrel =
CDBS_PREDEPENDS = $(if $(DEB_HOST_MULTIARCH),multiarch-support)

# avoid compressing documentation
DEB_COMPRESS_EXCLUDE_DEFAULT += .html

# install editorconfig binaries, man pages and docs
DEB_DH_INSTALL_ARGS_$(pkg-bin) = usr/bin
DEB_INSTALL_MANPAGES_$(pkg-bin) = \
	debian/tmp/usr/share/man/man1/editorconfig.1 \
	debian/tmp/usr/share/man/man3/editorconfig-format.3
DEB_DH_LINK_$(pkg-bin) = /usr/share/man/man1/editorconfig.1.gz \
	/usr/share/man/man1/editorconfig-$(DEB_UPSTREAM_VERSION).1.gz
DEB_DH_INSTALL_ARGS_$(pkg-doc) = usr/share/doc/editorconfig-doc/html/

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
#  * d-shlibs 0.48 required for --multiarch and --exclude-la options
CDBS_BUILD_DEPENDS += , d-shlibs (>= 0.48)
binary-post-install/$(pkg-lib) binary-post-install/$(pkg-dev):: \
 debian/stamp-local-shlibs-$(lib)
debian/stamp-local-shlibs-$(lib): \
 binary-install/$(pkg-lib) binary-install/$(pkg-dev)
	d-shlibmove --commit \
		--devunversioned \
		--multiarch \
		--exclude-la \
		--override s/$(lib)$(major)-dev/$(lib)-dev/ \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		debian/tmp/usr/lib/$(lib).so
	touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(lib)

# use separately packaged jquery
CDBS_BUILD_DEPENDS +=, libjs-jquery
CDBS_DEPENDS_$(pkg-doc) += , libjs-jquery
DEB_DH_LINK_$(pkg-doc) = /usr/share/javascript/jquery/jquery.js \
	/usr/share/doc/$(pkg-doc)/html/jquery.js

=== debian/watch ===
version = 3
https://github.com/editorconfig/editorconfig-core-c/tags .*/v([\d.]*)\.tar\.gz

## editorconfig-core 0.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2011-2013 EditorConfig Team
+# Copyright (c) 2011-2016 EditorConfig Team
 # All rights reserved.
 # 
 # Redistribution and use in source and binary forms, with or without
@@ -24,11 +24,12 @@
 # POSSIBILITY OF SUCH DAMAGE.
 #
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.7)
+cmake_policy(VERSION 2.8.7)
 
 set (editorconfig_VERSION_MAJOR 0)
 set (editorconfig_VERSION_MINOR 12)
-set (editorconfig_VERSION_SUBMINOR 0)
+set (editorconfig_VERSION_PATCH 1)
 
 set (editorconfig_VERSION_SUFFIX "")
 
@@ -58,7 +59,7 @@
 set(CPACK_PACKAGE_VENDOR "EditorConfig Team")
 set(CPACK_PACKAGE_VERSION_MAJOR ${editorconfig_VERSION_MAJOR})
 set(CPACK_PACKAGE_VERSION_MINOR ${editorconfig_VERSION_MINOR})
-set(CPACK_PACKAGE_VERSION_PATCH ${editorconfig_VERSION_SUBMINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${editorconfig_VERSION_PATCH})
 set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
 set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
 set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -38,8 +38,10 @@
 
     if(DOXYGEN_FOUND)
 
-        # Generating the major part of the doc. Although it generates
+        # Generating the main part of the doc. Although it generates
         # editorconfig.3, we discard that file
+        set(DOC_MAN_SECTION 3)
+        set(DOC_GEN_HTML "YES")
         configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
             ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
 
@@ -54,42 +56,68 @@
             ${PROJECT_SOURCE_DIR}/logo/logo.png
             WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
 
+        set(EC_MANPAGE_DIR ${CMAKE_CURRENT_BINARY_DIR}/man)
+        set(EC_MANPAGE1_DIR ${EC_MANPAGE_DIR}/man1)
+        set(EC_MANPAGE3_DIR ${EC_MANPAGE_DIR}/man3)
+        set(EC_MANPAGE5_DIR ${EC_MANPAGE_DIR}/man5)
+
         # Generating man page of editorconfig command. Although we have other
         # .1s other than editorconfig.1, we ignore them
-        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_cmd.in
-            ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_cmd)
+        set(DOC_MAN_SECTION 1)
+        set(DOC_GEN_HTML "NO")
+        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
+            ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-1)
 
         add_custom_command(
             OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/man/man1/editorconfig.1
             COMMAND
-            ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_cmd"
+            ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-1"
             MAIN_DEPENDENCY
-            ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile_cmd.in
+            ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
             DEPENDS
             ${PROJECT_SOURCE_DIR}/include/editorconfig/editorconfig.h
             WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
 
+        # Generating man page editorconfig-format.5. Although we have other
+        # .5s other than editorconfig-format.5, we ignore them
+        set(DOC_MAN_SECTION 5)
+        set(DOC_GEN_HTML "NO")
+        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
+            ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-5)
+
+        add_custom_command(
+            OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/man/man5/editorconfig-format.5
+            COMMAND
+            ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-5"
+            MAIN_DEPENDENCY
+            ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
+            DEPENDS
+            ${PROJECT_SOURCE_DIR}/include/editorconfig/editorconfig.h
+            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
+
+        # doc generation target
         add_custom_target(doc ALL DEPENDS
             ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
-            ${CMAKE_CURRENT_BINARY_DIR}/man/man1/editorconfig.1)
+            ${EC_MANPAGE1_DIR}/editorconfig.1
+            ${EC_MANPAGE5_DIR}/editorconfig-format.5)
 
         # install man pages
-        set(EC_MANPAGE_DIR ${CMAKE_CURRENT_BINARY_DIR}/man)
-        set(EC_MANPAGE3_DIR ${EC_MANPAGE_DIR}/man3)
-
         # Since we cannot avoid generating editorconfig.3 with doxygen, which
         # is the manpage of the command line interface with a manpage number 3,
-        # we need to exclude it when installing man3.
+        # we need to exclude it when installing man3. Same for
+        # editorconfig-format.3
         install(DIRECTORY ${EC_MANPAGE3_DIR}
             DESTINATION share/man
             PATTERN editorconfig.3 EXCLUDE
+            PATTERN editorconfig-format.3 EXCLUDE
             REGEX ._include_. EXCLUDE)
-
-        set(EC_MANPAGE1_DIR ${EC_MANPAGE_DIR}/man1)
 
         install(FILES
             ${EC_MANPAGE1_DIR}/editorconfig.1
             DESTINATION share/man/man1)
+        install(FILES
+            ${EC_MANPAGE5_DIR}/editorconfig-format.5
+            DESTINATION share/man/man5)
 
         # "make clean" should also clean generated docs
         set_directory_properties(PROPERTIES

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -54,10 +54,12 @@
 include_directories(BEFORE
     "${PROJECT_SOURCE_DIR}/include")
 
-# MSVC_MD option
-option(MSVC_MD
-    "Use /MD instead of /MT flag when compiling with Microsoft Visual C++. This option takes no effect when using compilers other than Microsoft Visual C++."
-    OFF)
+if(WIN32)
+    # MSVC_MD option
+    option(MSVC_MD
+        "Use /MD instead of /MT flag when compiling with Microsoft Visual C++. This option takes no effect when using compilers other than Microsoft Visual C++."
+        OFF)
+endif()
 
 # replace all /MD with /MT for msvc if MSVC_MD is off
 if(MSVC AND NOT MSVC_MD)
@@ -70,6 +72,13 @@
     endforeach(flag_var)
 endif()
 
+# Use unsigned char to represent plain char
+if(MSVC)
+    add_definitions("-J")
+else()
+    add_definitions("-funsigned-char")
+endif()
+
 add_subdirectory(lib)
 add_subdirectory(bin)

=== src/bin/CMakeLists.txt ===
#
# Copyright (c) 2011-2012 EditorConfig Team
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

link_directories(${CMAKE_ARCHIVE_OUTPUT_DIR})

# for gcc, BUILD_STATICALLY_LINKED_EXE_DEFAULT_VAL is OFF
if(CMAKE_COMPILER_IS_GNUCC)
    set(BUILD_STATICALLY_LINKED_EXE_DEFAULT_VAL OFF)
endif(CMAKE_COMPILER_IS_GNUCC)

option(BUILD_STATICALLY_LINKED_EXE
    "Link the standard library statically when building the executable.(Only valid for gcc)"
    ${BUILD_STATICALLY_LINKED_EXE_DEFAULT_VAL})

if(CMAKE_COMPILER_IS_GNUCC)
    if(BUILD_STATICALLY_LINKED_EXE)
        # Add -static for linker if we want a statically linked executable
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif(BUILD_STATICALLY_LINKED_EXE)
endif(CMAKE_COMPILER_IS_GNUCC)

set(editorconfig_BINSRCS
    main.c)

# targets
add_executable(editorconfig_bin ${editorconfig_BINSRCS})
target_link_libraries(editorconfig_bin editorconfig_static)
set_target_properties(editorconfig_bin PROPERTIES
    OUTPUT_NAME editorconfig
    VERSION
    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_PATCH})

install(TARGETS editorconfig_bin
    RUNTIME DESTINATION bin)

=== src/lib/CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,10 @@
 # POSSIBILITY OF SUCH DAMAGE.
 #
 
+include(GNUInstallDirs)
+
 set(editorconfig_LIBSRCS
-    ec_fnmatch.c
+    ec_glob.c
     editorconfig.c
     editorconfig_handle.c
     ini.c
@@ -37,26 +39,28 @@
     OUTPUT_NAME editorconfig
     SOVERSION 0
     VERSION
-    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_SUBMINOR})
+    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_PATCH})
 
 # We need to link Shwapi since we use PathIsRelative
 if(WIN32)
     target_link_libraries(editorconfig_shared Shlwapi)
 endif()
+target_link_libraries(editorconfig_shared ${PCRE_LIBRARIES})
 
 add_library(editorconfig_static STATIC ${editorconfig_LIBSRCS})
 set_target_properties(editorconfig_static PROPERTIES
     OUTPUT_NAME editorconfig_static
     VERSION
-    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_SUBMINOR})
+    ${editorconfig_VERSION_MAJOR}.${editorconfig_VERSION_MINOR}.${editorconfig_VERSION_PATCH})
 
 # We need to link Shwapi since we use PathIsRelative
 if(WIN32)
     target_link_libraries(editorconfig_static Shlwapi)
 endif()
+target_link_libraries(editorconfig_static ${PCRE_LIBRARIES})
 
 install(TARGETS editorconfig_shared editorconfig_static
-    RUNTIME DESTINATION bin
-    LIBRARY DESTINATION lib
-    ARCHIVE DESTINATION lib)
+    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== debian/changelog ===
editorconfig-core (0.12.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Drop explicit Pre-Depends on multiarch-support
    (Closes: #870509).

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 20 Jan 2018 22:17:16 +0100

editorconfig-core (0.12.1-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    + Fix avoid calling exit()
      Closes: Bug#818625.
    + Bump required minimum cmake version to 2.8.7.
    + Use GNU installation dirs for OS portability.

  [ Jonas Smedegaard ]
  * Modernize watch file, and add usage hint comment.
  * Drop CDBS get-orig-source target: Use "gbp import-orig --uscan"
    instead.
  * Declare compliance with Debian Policy 3.9.7.
  * Modernize Vcs-Git field: Use https protocol.
  * Update copyright info:
    + Extend coverage for main upstream author.
    + Extend copyright of packaging to cover current year.
    + Use License-Grant and License-Reference fields.
      Thanks to Ben Finney.
  * Add lintian override regarding license in License-Reference field.
    See bug#786450.
  * Build-depend unversioned on debhelper: Needed version satisfied even
    in oldstable.
  * Add lintian override regarding debhelper 9.
  * Update/unfuzz patches.
  * Install development man pages, and adjust section for file format
    man page.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 25 Mar 2016 14:03:18 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Build-Depends: cdbs,
- debhelper (>= 9~),
+ debhelper,
  devscripts,
  cmake,
  doxygen,
@@ -11,9 +11,9 @@
  libjs-jquery
 Maintainer: Jonas Smedegaard <dr@jones.dk>
 Uploaders: Vasudev Kamath <kamathvasudev@gmail.com>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://editorconfig.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/editorconfig-core.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/editorconfig-core.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/editorconfig-core.git
 
 Package: libeditorconfig0

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 # -*- mode: makefile; coding: utf-8 -*-
 # Copyright © 2013 Vasudev Kamath <kamathvasudev@gmail.com>
-# Copyright © 2013, 2015 Jonas Smedegaard <dr@jones.dk>
+# Copyright © 2013, 2015-2016 Jonas Smedegaard <dr@jones.dk>
 # Description: Main Debian packaging script for EditorConfig core
 #
 # This program is free software; you can redistribute it and/or modify
@@ -30,7 +30,6 @@
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/rules/utils.mk
-include /usr/share/cdbs/1/rules/upstream-tarball.mk
 include /usr/share/cdbs/1/class/cmake.mk
 
 lib = lib$(stem)
@@ -38,9 +37,9 @@
 pkg-bin = $(stem)
 pkg-doc = $(stem)-doc
 
-# Upstream tarball handling
-DEB_UPSTREAM_URL = https://github.com/editorconfig/editorconfig-core/archive
-DEB_UPSTREAM_TARBALL_BASENAME = v$(DEB_UPSTREAM_TARBALL_VERSION)
+# Build-depend unversioned on debhelper
+#  TODO: Drop when adopted in cdbs
+CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper
 
 # Build Depends
 CDBS_BUILD_DEPENDS += , cmake, doxygen, libpcre3-dev
@@ -51,7 +50,6 @@
 # Multiarch quirks (should ideally be resolved automagically)
 CDBS_BUILD_DEPENDS_rules_debhelper_buildinfo =
 CDBS_BUILD_DEPENDS_rules_buildcore_pkgrel =
-CDBS_PREDEPENDS = $(if $(DEB_HOST_MULTIARCH),multiarch-support)
 
 # avoid compressing documentation
 DEB_COMPRESS_EXCLUDE_DEFAULT += .html
@@ -60,7 +58,8 @@
 DEB_DH_INSTALL_ARGS_$(pkg-bin) = usr/bin
 DEB_INSTALL_MANPAGES_$(pkg-bin) = \
 	debian/tmp/usr/share/man/man1/editorconfig.1 \
-	debian/tmp/usr/share/man/man3/editorconfig-format.3
+	debian/tmp/usr/share/man/man5/editorconfig-format.5
+DEB_INSTALL_MANPAGES_$(pkg-dev) = debian/tmp/usr/share/man/man3/*.3
 DEB_DH_LINK_$(pkg-bin) = /usr/share/man/man1/editorconfig.1.gz \
 	/usr/share/man/man1/editorconfig-$(DEB_UPSTREAM_VERSION).1.gz
 DEB_DH_INSTALL_ARGS_$(pkg-doc) = usr/share/doc/editorconfig-doc/html/
@@ -79,7 +78,7 @@
 		--exclude-la \
 		--override s/$(lib)$(major)-dev/$(lib)-dev/ \
 		--movedev "debian/tmp/usr/include/*" usr/include/ \
-		debian/tmp/usr/lib/$(lib).so
+		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$(lib).so
 	touch $@
 clean::
 	rm -f debian/stamp-local-shlibs-$(lib)

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version = 4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%editorconfig-core-c-$1.tar.gz%" \
 https://github.com/editorconfig/editorconfig-core-c/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
